<?php
function file_generator($filename) {
    $handle = fopen($filename, 'r');

    try {
        while (($line = fgets($handle)) !== false) {
            yield $line;
        }
    } finally {
        fclose($handle);
    }
}

$f = file_generator('file');

foreach ($f as $line) {
    echo $line;
}