<?php
const COST = 10;

$hash = $db->getHash($user_id);

if (!password_verify($password, $hash)) {
    // パスワード不一致
}

if (password_needs_rehash($hash, $algo, ['cost' => COST])) {
    $rehash = password_hash(
        $password,
        $algo,
        ['cost' => COST]
    );
    // $user_idのパスワードハッシュを更新する
    $db->update($user_id, $rehash);
}

// ...
