<?php
class myIterator implements Iterator {
    private $pos = 0;
    private $array = [1, 2, 3];

    public function rewind() {
        $this->pos = 0;
    }

    public function current() {
        return $this->array[$this->pos];
    }

    public function key() {
        return [$this->pos];
    }

    public function next() {
        $this->pos++;
    }

    public function valid() {
        return isset($this->array[$this->pos]);
    }
}

$it = new myIterator;

foreach ($it as $k => $v) {
    var_dump($k, $v);
}
